unit ehs_demoUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls, Buttons, ComCtrls, ehscontextmap,
  ehshelprouter, ehsbase, ehswhatsthis;


type
  TForm1 = class(TForm)
    WhatsThis1: TWhatsThis;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuHelp: TMenuItem;
    mnuHelpTOC: TMenuItem;
    mnuHelpKeywords: TMenuItem;
    mnuHelpFTS: TMenuItem;
    N1: TMenuItem;
    mnuWhatsthis: TMenuItem;
    PageControl1: TPageControl;
    TabWhatsthis: TTabSheet;
    gbOptions: TGroupBox;
    Label1: TLabel;
    cbwtDirectHelp: TCheckBox;
    cbwtMenuRightClick: TCheckBox;
    cbwtNoContextHelp: TCheckBox;
    cbwtInheritFormContext: TCheckBox;
    cbwtNoContextMenu: TCheckBox;
    cbwtPopupOnForm: TCheckBox;
    cbwtUseTag: TCheckBox;
    mnuEdit: TMenuItem;
    mnuUndo: TMenuItem;
    N2: TMenuItem;
    mnuCut: TMenuItem;
    mnuCopy: TMenuItem;
    mnuPaste: TMenuItem;
    mnuOpen: TMenuItem;
    mnuSave: TMenuItem;
    mnuPrint: TMenuItem;
    N3: TMenuItem;
    mnuExit: TMenuItem;
    Label2: TLabel;
    cbActive: TComboBox;
    Label3: TLabel;
    cbF1Action: TComboBox;
    Label4: TLabel;
    gbWincontrols: TGroupBox;
    Edit1: TEdit;
    ListBox1: TListBox;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    ComboBox1: TComboBox;
    gbGraphiccontrols: TGroupBox;
    Image1: TImage;
    Shape1: TShape;
    Bevel2: TBevel;
    Label9: TLabel;
    Label10: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label11: TLabel;
    Label12: TLabel;
    mnuNew: TMenuItem;
    pnlToolbar: TPanel;
    btnNew: TSpeedButton;
    btnOpen: TSpeedButton;
    btnSave: TSpeedButton;
    btnPrint: TSpeedButton;
    btnUndo: TSpeedButton;
    btnCut: TSpeedButton;
    btnCopy: TSpeedButton;
    btnPase: TSpeedButton;
    btnWhatsThis: TSpeedButton;
    btnHelpTOC: TSpeedButton;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Label13: TLabel;
    HelpRouter1: THelpRouter;
    Label14: TLabel;
    cbHelpType: TComboBox;
    TabHelpContextMap: TTabSheet;
    gbControlsnoHC: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Edit2: TEdit;
    RadioGroup1: TRadioGroup;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    SpeedButton3: TSpeedButton;
    Label19: TLabel;
    Shape2: TShape;
    HelpContextMap1: THelpContextMap;
    PopupMenu1: TPopupMenu;
    PopupmenuforListbox11: TMenuItem;
    cbwtUseAppKey: TCheckBox;
    procedure ContextOptionsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuDummyClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure cbActiveChange(Sender: TObject);
    procedure cbF1ActionChange(Sender: TObject);
    procedure mnuHelpTOCClick(Sender: TObject);
    procedure cbHelpTypeChange(Sender: TObject);
    procedure PopupmenuforListbox11Click(Sender: TObject);
    procedure mnuHelpKeywordsClick(Sender: TObject);
    procedure mnuHelpFTSClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     application.helpfile := changefileext(application.exename, '.hlp');
     PageControl1.activepage := TabWhatsThis;
     cbActive.itemindex   := integer(WhatsThis1.active);
     cbF1Action.itemindex := integer(WhatsThis1.F1Action);
     cbHelpType.itemindex := integer(HelpRouter1.HelpType);
end;

procedure TForm1.ContextOptionsClick(Sender: TObject);
var
   wtOption: TWhatsThisOption;
   wtOptionSet: TWhatsThisOptions;
begin
     if sender = cbwtDirectHelp         then wtOption := wtDirectHelp;
     if sender = cbwtMenuRightClick     then wtOption := wtMenuRightClick;
     if sender = cbwtNoContextHelp      then wtOption := wtNoContextHelp;
     if sender = cbwtNoContextMenu      then wtOption := wtNoContextMenu;
     if sender = cbwtPopupOnForm        then wtOption := wtPopupOnForm;
     if sender = cbwtInheritFormContext then wtOption := wtInheritFormContext;
     if sender = cbwtUseTag             then wtOption := wtUseTag;
     if sender = cbwtUseAppKey          then wtOption := wtUseAppKey;
     wtOptionSet := WhatsThis1.options;
     if TCheckbox(Sender).checked
       then include(wtOptionSet, wtOption)
       else exclude(wtOptionSet, wtOption);
     WhatsThis1.options := wtOptionSet;
end;

procedure TForm1.MenuDummyClick(Sender: TObject);
begin
     MessageDlg('This menu item is a dummy and does nothing.'+#13#10
               +'There is, however, context sensitive help available for every item.'+#13#10
               +'Just right-click a menu item to display it''s help topic',
               mtInformation,
               [mbOK],
               0);
end;

procedure TForm1.mnuExitClick(Sender: TObject);
begin
     Close;
end;

procedure TForm1.cbActiveChange(Sender: TObject);
begin
     WhatsThis1.active := boolean(cbActive.itemindex);
     btnWhatsThis.enabled := WhatsThis1.active;
     mnuWhatsThis.enabled := WhatsThis1.active;
end;

procedure TForm1.cbF1ActionChange(Sender: TObject);
begin
     WhatsThis1.F1Action := TF1Action(cbF1Action.itemindex);
end;

procedure TForm1.mnuHelpTOCClick(Sender: TObject);
begin
     helprouter1.HelpContent;
end;

procedure TForm1.cbHelpTypeChange(Sender: TObject);
begin
     HelpRouter1.HelpType := THelpType(cbHelpType.itemindex);
     if (cbHelpType.itemindex > 0) and (not HelpRouter1.HTMLHelpInstalled) then
     begin
          HelpRouter1.HelpType := htWinhelp;
          cbHelpType.itemindex := 0;
          MessageDlg('Cannot load HTML HELP OCX control.'+#13+#10+
                     'Help mode is reset to Winhelp format',
                     mtError,
                     [mbOK],
                     0);
     end;
end;

procedure TForm1.PopupmenuforListbox11Click(Sender: TObject);
begin
     MessageDlg('Listbox1 has it''s own popup menu that appears after a right mouse click.'+#13#10
               +'TWhatsThis automatically recognizes popup menus and does NOT display a What''s this? menu in this case.'+#13#10
               +'This even works with popup menus that your program may display manually in the OnMouseUp event.',
               mtInformation,
               [mbOK],
               0);
end;

procedure TForm1.mnuHelpKeywordsClick(Sender: TObject);
begin
     helprouter1.HelpKeyword('');
end;

procedure TForm1.mnuHelpFTSClick(Sender: TObject);
begin
     Application.helpcommand(15, -1);
end;

end.
